#include <util/delay.h>
#include <avr/io.h>
#include "FreeRTOS/FreeRTOS.h"
#include "FreeRTOS/task.h"
#include "procutil/procutil.h"

#define ever  (;;)


#define LED_R(x) ((x) ? PORTD.DIRSET = _BV(5) : (PORTD.DIRCLR = _BV(5)))
#define LED_Y(x) ((x) ? PORTD.DIRSET = _BV(6) : (PORTD.DIRCLR = _BV(6)))
#define LED_G(x) ((x) ? PORTD.DIRSET = _BV(7) : (PORTD.DIRCLR = _BV(7)))


void task1(void* p)
{
  for ever
  {
    LED_R(0);
    vTaskDelay(250);
    LED_R(1);
    vTaskDelay(750);
  }
}


void task2(void* p)
{
  for ever
  {
    LED_Y(0);
    vTaskDelay(500);
    LED_Y(1);
    vTaskDelay(500);
  }
}


void task3(void* p)
{
  for ever
  {
    LED_G(0);
    vTaskDelay(1450);
    LED_G(1);
    vTaskDelay(50);
  }
}


int main(void)
{
  _delay_ms(200UL * 2000000UL/F_CPU); // 200ms @ 2MHz (2MHz: startup-default clock)
  
  procutil_clk_RC32MHz_en();
  procutil_clk_32MHz_from_RC32MHz();
  procutil_int_pmic_enable_all();
  
  xTaskCreate(task1, "Blink1", configMINIMAL_STACK_SIZE, NULL, PRIORITY_LOW, NULL);
  xTaskCreate(task2, "Blink2", configMINIMAL_STACK_SIZE, NULL, PRIORITY_LOW, NULL);
  xTaskCreate(task3, "Blink3", configMINIMAL_STACK_SIZE, NULL, PRIORITY_LOW, NULL);
  
  vTaskStartScheduler(); // interrupts are enabled here
}


void vApplicationStackOverflowHook( TaskHandle_t xTask, signed char *pcTaskName )
{
  for ever;
}








